package framework.handler;

import framework.integration.SimulationAgentWrapper;
import framework.services.*;
import framework.services.avaliableServices.*;
import model.conection.Request;
import model.handler.Handler;
import model.proccesor.RequestDictionary;

import java.util.HashMap;

public class HandlerDictionary extends HashMap<String, Handler>implements RequestDictionary {

    private final SimulationAgentWrapper agent;

    public HandlerDictionary(SimulationAgentWrapper simulationAgentWrapper) {
        super();
        this.agent = simulationAgentWrapper;
        init();
    }

    private void init(){
        put("/Breakpoint:DELETE", request -> breakpointService().delete(request));
        put("/Breakpoint:POST", request -> breakpointService().create(request));

        put("/Sensor:POST",   request -> sensorService().installSensor(request));
        put("/Sensor:DELETE",   request -> sensorService().remove(request));
        put("/Subscribe:POST", request -> subscriptionService().subscribe(request));
    }

    @Override
    public Handler find(Request request) {
        if(get(request.getPath() + ":" + request.getMethod())!= null)
            return get(request.getPath() + ":" + request.getMethod());
        return agent::execute;
    }

    private SubscriptionService subscriptionService() {
        return ServicesManager.get(SubscriptionService.class);
    }

    private SensorService sensorService() {
        return ServicesManager.get(SensorService.class);
    }

    private BreakpointService breakpointService() {
        return ServicesManager.get(BreakpointService.class);
    }



}


