package framework.integration.agentActions;

import framework.integration.SimulationAgent;
import framework.integration.simulation.SimulationState;
import model.conection.HttpResponse;
import model.conection.Request;
import model.conection.Response;

import static framework.serverState.ServerState.state;

public class Pause implements AgentAction {
    private final SimulationAgent agent;

    public Pause(SimulationAgent agent) {
        this.agent = agent;
    }

    @Override
    public Response execute(Request request) {
        boolean result = agent.pause();
        if (result) state().setSimulationState(SimulationState.PAUSE);
        return createResponse(result);
    }

    private Response createResponse(boolean result) {
        if(result)
            return new HttpResponse(200, "{\"message\":\"simulation paused\"}");
        return new HttpResponse(500, "{\"error\":\"impossible pause simulation\"}");
    }
}
