package framework.integration.agentActions;

import framework.integration.SimulationAgent;
import framework.integration.simulation.SimulationState;
import model.conection.HttpResponse;
import model.conection.Request;
import model.conection.Response;

import static framework.serverState.ServerState.state;

public class Reset implements AgentAction {
    private SimulationAgent agent;

    public Reset(SimulationAgent agent) {
        this.agent = agent;
    }

    @Override
    public Response execute(Request request) {
        boolean result = agent.reset();
        if(result) state().setSimulationState(SimulationState.RESET);
        return createResponse(result);
    }

    private Response createResponse(boolean result) {
        if(result)
            return new HttpResponse(200, "{\"message\":\"simulation stopped\"}");
        return new HttpResponse(500, "{\"error\":\"impossible reset simulation\"}");
    }
}
