package framework.services.defaultServices;

import framework.integration.simulation.Watcher;
import framework.services.avaliableServices.SensorService;
import model.conection.HttpResponse;
import model.conection.Request;
import model.conection.Response;

import static framework.serverState.ServerState.state;

public class SensorsService implements SensorService {

    @Override
    public Response installSensor(Request request) {
        Watcher watcher = new Watcher(request.getParameter("objectId"), request.getParameter("measurableAttributeName"));
        state().watcherContainer().addWatcher(request.getParameter("username"), watcher);
        return new HttpResponse(200, "{\"message\":\"sensors installed\"}");
    }

    @Override
    public HttpResponse remove(Request request) {
        Watcher watcher = new Watcher(request.getParameter("objectId"), request.getParameter("measurableAttributeName"));
        state().watcherContainer().removeUserWatcher(request.getParameter("username"), watcher);
        return new HttpResponse(200, "{\"message\":\"sensors remove\"}");
    }
}
