package framework.handler;

import framework.integration.SimulationAgentWrapper;
import framework.services.ServicesManager;
import framework.services.avaliableServices.BreakpointService;
import framework.services.avaliableServices.FrameworkService;
import framework.services.servicesFinder.ServiceFinder;
import model.conection.HttpRequest;
import model.handler.Handler;
import org.junit.Test;

import java.util.HashMap;
import java.util.Map;

import static exception.ExceptionHandler.getSafe;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

public class TestHandlerDictionary {

    private HandlerDictionary dictionary;

    @Test
    public void givePlayHandler() {
        ServiceFinder finder = mock(ServiceFinder.class);
        when(finder.search("framework")).thenReturn(getServiceList(BreakpointService.class));
        ServicesManager.setUp(finder, "framework");

        Handler handler = new HandlerDictionary(new SimulationAgentWrapper(null)).find(getSafe(()->new HttpRequest("POST", "/Play", "")));
        //assertSame(Play.class, handler);
    }

    private Map<Class<?>, Class<? extends FrameworkService>> getServiceList(Class<BreakpointService> service) {
        Map<Class<?>, Class<? extends FrameworkService>> classes = new HashMap<>();
        classes.put(service.getInterfaces()[0], service);
        return classes;
    }


}
