package integrationTest;

import framework.SGIFramework;
import sites.Application;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

import static exception.ExceptionHandler.getSafe;
import static exception.ExceptionHandler.runSafe;

public class Main {

    public static void main(String[] args) throws Exception {
        Application.run(null);

        Service service = new Service("Simulation32", initialDate(), finalDate());
        new Thread(() -> {
            while (true) {
                runSafe(() -> Thread.sleep(300));
                service.refresh(null);
            }
        }).start();
    }

    public static Date initialDate() {
        DateFormat format = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
        return getSafe(() -> format.parse("05/29/2015 11:00:00"));
    }

    public static Date finalDate() {
        DateFormat format = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
        return getSafe(() -> format.parse("05/29/2015 12:00:00"));
    }

    public static class Service extends SGIFramework {
        public Service(String label, Date initialDate, Date finalDate) {
            super(label, initialDate, finalDate);
        }

        @Override
        public List<String> roots() {
            LinkedList<String> list = new LinkedList<>();
            list.add("happy-building");
            list.add("bored-building");
            list.add("unhappy-building");
            return list;
        }

        @Override
        public List<String> childrenOf(String objectId) {
            LinkedList<String> list = new LinkedList<>();
            list.add("room1");
            list.add("room2");
            list.add("room3");
            return list;
        }

        @Override
        public List<String> attributesOf(String objectId) {
            LinkedList<String> list = new LinkedList<>();
            list.add("sensor1");
            list.add("sensor2");
            list.add("sensor3");
            return list;
        }

        @Override
        public String valueGet(String objectId) {
            return "3";
        }

        @Override
        public boolean valueSet(String objectId, String value) {
            return false;
        }

        @Override
        public boolean play() {
            return false;
        }

        @Override
        public boolean pause() {
            return false;
        }

        @Override
        public boolean reset() {
            return false;
        }
    }

}
