package integrationTest.services;

import framework.services.ServicesManager;
import framework.services.avaliableServices.NotificationService;
import model.conection.HttpResponse;
import model.conection.Request;
import model.conection.Response;

import java.util.Random;

import static exception.ExceptionHandler.runSafe;

public class Sensors implements framework.services.avaliableServices.SensorService {

    @Override
    public Response installSensor(Request request) {
        if(request.getParameter("objectId")==null)
            return new HttpResponse(400, "{\"error\":\"error parameter objectId not found\"}");
        if(request.getParameter("measurableAttributeName")==null)
            return new HttpResponse(400, "{\"error\":\"error parameter measurableAttributeName not found\"}");

        sendSensorNotifications(request.getParameter("username"), request.getParameter("objectId"), request.getParameter("measurableAttributeName"));
        return new HttpResponse(200, "200");

    }

    @Override
    public HttpResponse remove(Request request) {
        return null;
    }

    private void sendSensorNotifications(String username, String objectId, String measurableAttributeName) {
        new Thread(() -> {
            int time = 0;
            while (true) {
                int value = new Random().nextInt(50) + 1;
                String message = "{\"type\":\"sensorValues\", \"info\":{\"time\":\"05/29/2015 11:" + time + ":00\", \"measurableAttributeName\":\"" + measurableAttributeName + "\",\"value\":"+value+", \"objectId\":\"" + objectId +"\"}}";

                ServicesManager.get(NotificationService.class).push(username, message);
                runSafe(() -> Thread.sleep(5000));
                time++;
            }
//            System.out.println("finalizado envio de sensor");//TODO
        }).start();
    }

}
