package integrationTest.services;

import framework.services.ServicesManager;
import framework.services.avaliableServices.NotificationService;
import framework.services.avaliableServices.SubscriptionService;
import model.conection.HttpResponse;
import model.conection.Request;
import model.conection.Response;

public class Subscriptions implements SubscriptionService {

    @Override
    public Response subscribe(Request request) {
        if(request.getParameter("username")==null)
            return new HttpResponse(400, "{\"error\":\"error parameter objectId not found\"}");

        sendInitGraphicNotification(request.getParameter("username"), "05/29/2015 11:00:00", "05/29/2015 12:00:00", 1000);
        return new HttpResponse(200, "{\"message\":\"Ok\"}");
    }

    private void sendInitGraphicNotification(String username, String initialTime, String endTime, long precision) {
        String message = "{\"type\":\"initGraphic\", \"info\":{\"init\":\"" + initialTime + "\", \"end\":\"" + endTime + "\",\"precision\":"+precision+"}}";
        new Thread(() -> {
            try {
                Thread.sleep(500);
                ServicesManager.get(NotificationService.class).push(username, message);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }).start();
    }
}
