package sites;

import Controller.HttpService;
import connection.DatagramConnection;
import sites.route.HandlerDictionary;
import sites.route.notification.NotificationServer;
import sites.route.notification.WebSocketConnection;
import sites.sgiSubscription.SimulatorSubscriptionsService;

public class Application {
    //TODO puede que para usar el mismo puerto haya k diferenciar si viene de websocket o de Http puro
    public static void run(String[] args) throws Exception {
        new SimulatorSubscriptionsService(new DatagramConnection(0xCAB0)).start();
        new HttpService(new RouterRequestProcessor(new HandlerDictionary()) , 8080).start();
        setUpNotificationServer();
    }

    private static void setUpNotificationServer() {
        WebSocketConnection connection = new WebSocketConnection(8081);
        connection.start();
        NotificationServer.instance().setConnection(connection);
    }


}
