package sites.route.handler;

import sites.route.notification.NotificationServer;
import sites.route.identification.UserIdentification;
import model.conection.HttpResponse;
import model.conection.Request;
import model.conection.Response;
import model.handler.Handler;
import org.java_websocket.exceptions.WebsocketNotConnectedException;

public class NotificationHandler implements Handler{
    @Override
    public Response handle(Request request) {
        try {
            NotificationServer.instance().sendNotification(getUserIdentification(request), removeSimulationParameters(request).getBody());
        } catch (WebsocketNotConnectedException exception) {
            return new HttpResponse(500, "{\"error\":\"user "+request.getParameter("username")+" socket closed\"}");
        }
        return new HttpResponse(200, "{\"message\":\"Ok\"}");
    }

    private Request removeSimulationParameters(Request request) {
        request.removeParameter("simulationId");
        request.removeParameter("username");
        return request;
    }

    private UserIdentification getUserIdentification(Request request) {
        return new UserIdentification(request.getParameter("username"), request.getParameter("simulationId"));
    }
}